package javax.tools;

import java.util.Iterator;
import java.io.IOException;
import java.util.Set;

public class ForwardingJavaFileManager<M extends JavaFileManager> implements JavaFileManager
{
    protected final M fileManager;
    
    protected ForwardingJavaFileManager(M fileManager) {
        fileManager.getClass();
        this.fileManager = fileManager;
    }
    
    @Override
    public ClassLoader getClassLoader(JavaFileManager.Location location) {
        return this.fileManager.getClassLoader(location);
    }
    
    @Override
    public Iterable<JavaFileObject> list(JavaFileManager.Location location, String s, Set<JavaFileObject.Kind> set, boolean b) throws IOException {
        return this.fileManager.list(location, s, set, b);
    }
    
    @Override
    public String inferBinaryName(JavaFileManager.Location location, JavaFileObject javaFileObject) {
        return this.fileManager.inferBinaryName(location, javaFileObject);
    }
    
    @Override
    public boolean isSameFile(FileObject fileObject, FileObject fileObject2) {
        return this.fileManager.isSameFile(fileObject, fileObject2);
    }
    
    @Override
    public boolean handleOption(String s, Iterator<String> iterator) {
        return this.fileManager.handleOption(s, iterator);
    }
    
    @Override
    public boolean hasLocation(JavaFileManager.Location location) {
        return this.fileManager.hasLocation(location);
    }
    
    @Override
    public int isSupportedOption(String s) {
        return this.fileManager.isSupportedOption(s);
    }
    
    @Override
    public JavaFileObject getJavaFileForInput(JavaFileManager.Location location, String s, JavaFileObject.Kind kind) throws IOException {
        return this.fileManager.getJavaFileForInput(location, s, kind);
    }
    
    @Override
    public JavaFileObject getJavaFileForOutput(JavaFileManager.Location location, String s, JavaFileObject.Kind kind, FileObject fileObject) throws IOException {
        return this.fileManager.getJavaFileForOutput(location, s, kind, fileObject);
    }
    
    @Override
    public FileObject getFileForInput(JavaFileManager.Location location, String s, String s2) throws IOException {
        return this.fileManager.getFileForInput(location, s, s2);
    }
    
    @Override
    public FileObject getFileForOutput(JavaFileManager.Location location, String s, String s2, FileObject fileObject) throws IOException {
        return this.fileManager.getFileForOutput(location, s, s2, fileObject);
    }
    
    @Override
    public void flush() throws IOException {
        this.fileManager.flush();
    }
    
    @Override
    public void close() throws IOException {
        this.fileManager.close();
    }
}
